package de.fernunihagen.rtt.framework.repository.team.svn.internal;

import static de.fernunihagen.rtt.internal.RTTCorePlugin.getRTTCorePlugin;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Pre;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Plugin;
import org.eclipse.core.runtime.Status;

import org.osgi.framework.BundleContext;

import de.fernunihagen.rtt.internal.PluginAdapter;

/**
 * The activator class controls the plug-in life cycle
 */
@Contract
public class RTTSVNRepositoryPlugin extends Plugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "de.fernunihagen.rtt.framework.repository.team.svn";

	// The shared instance
	private static RTTSVNRepositoryPlugin plugin;

	private PluginAdapter<RTTSVNRepositoryPlugin> _adapter;

	/**
	 * The constructor
	 */
	public RTTSVNRepositoryPlugin() {
		_adapter = null;
	}

	@Override
	@Pre("$this.PLUGIN_ID == context.getBundle().getSymbolicName()")
	public void start(final BundleContext context) throws Exception {
		try {
			super.start(context);
			plugin = this;
			_adapter = new PluginAdapter<RTTSVNRepositoryPlugin>(this,
					getRTTCorePlugin());
			getAdapter().logInfo(PLUGIN_ID + " started");
		} catch (Exception e) {
			getLog().log(new Status(IStatus.ERROR, PLUGIN_ID, null, e));
		}
	}

	@Override
	public void stop(final BundleContext context) throws Exception {
		_adapter.logInfo(PLUGIN_ID + " stopped");
		_adapter.close();
		_adapter = null;
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 * 
	 * @return the shared instance
	 */
	public static RTTSVNRepositoryPlugin getDefault() {
		return plugin;
	}

	/**
	 * Returns the adapted shared instance
	 * 
	 * @return the adapted shared instance
	 */
	public static PluginAdapter<? extends Plugin> getRTTSVNRepositoryPlugin() {
		return getDefault().getAdapter();
	}

	private PluginAdapter<? extends Plugin> getAdapter() {
		if (null == _adapter) {
			return null;
		}
		_adapter.init();
		return _adapter;
	}
}
