package de.fernunihagen.rtt.ui;

import static de.fernunihagen.rtt.ui.internal.RTTCoreUIPlugin.getDefault;

import org.contract4j5.contract.Contract;

import org.eclipse.core.runtime.CoreException;

import de.fernunihagen.rtt.ui.app.UIToolTestBench;

/**
 * RTT core UI services facade.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class RTTCoreUI {

	public static final String DEFAULT_APPLICATION = UIToolTestBench.ID;

	private RTTCoreUI() {

	}

	/**
	 * Sets the active test result content provider.
	 * 
	 * @param name
	 *            Test result content provider name
	 */
	public static void setActiveTestResultContentProvider(final String name) {
		getDefault().setActiveTestResultContentProvider(name);
	}

	/**
	 * Sets the active action adapter provider.
	 * 
	 * @param name
	 *            Name of action adapter provider
	 */
	public static void setActiveActionAdapterProvider(final String name) {
		getDefault().setActiveActionAdapterProvider(name);
	}

	/**
	 * Retrieves the action adapter provider.
	 * 
	 * @return Action adapter provider
	 * 
	 * @throws CoreException
	 *             <ul>
	 *             <li>If service unavailable</li>
	 *             <ul>
	 */
	public static IActionAdapterProvider getActionAdapterProvider()
			throws CoreException {
		return getDefault().getActionAdapterProvider();
	}
}
