package de.fernunihagen.rtt.ui.internal.jdt.launcher;

import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;

import org.eclipse.debug.ui.CommonTab;
import org.eclipse.debug.ui.EnvironmentTab;
import org.eclipse.debug.ui.ILaunchConfigurationDialog;
import org.eclipse.debug.ui.ILaunchConfigurationTab;

import org.eclipse.jdt.debug.ui.launchConfigurations.JavaArgumentsTab;

import org.eclipse.jdt.launching.IJavaLaunchConfigurationConstants;

import org.eclipse.pde.ui.launcher.AbstractPDELaunchConfigurationTabGroup;
import org.eclipse.pde.ui.launcher.ConfigurationTab;
import org.eclipse.pde.ui.launcher.IPDELauncherConstants;
import org.eclipse.pde.ui.launcher.MainTab;
import org.eclipse.pde.ui.launcher.PluginsTab;
import org.eclipse.pde.ui.launcher.TracingTab;

/**
 * Creates and initializes the tabs for the java refactoring tool test launch
 * configuration.
 * 
 * @author Osama El Hosami
 */
public final class RTTConfigurationTabGroup extends
		AbstractPDELaunchConfigurationTabGroup {

	private static final String DEFAULT_VM_ARGUMENTS = "-Xms40m -Xmx512m -XX:MaxPermSize=512m";
	private static final String DEFAULT_WORKSPACE_LOC = "${workspace_loc}/../rtt-workspace";

	@Override
	public void createTabs(final ILaunchConfigurationDialog dialog,
			final String mode) {
		setTabs(new ILaunchConfigurationTab[] { new ToolTestConfigurationTab(),
				new MainTab(), new JavaArgumentsTab(), new PluginsTab(false),
				new ConfigurationTab(true), new TracingTab(),
				new EnvironmentTab(), new CommonTab() });
	}

	@Override
	public void setDefaults(ILaunchConfigurationWorkingCopy configuration) {
		super.setDefaults(configuration);

		configuration.setAttribute(IPDELauncherConstants.LOCATION,
				DEFAULT_WORKSPACE_LOC);

		configuration.setAttribute(IPDELauncherConstants.DOCLEAR, true);
		configuration.setAttribute(IPDELauncherConstants.ASKCLEAR, false);

		configuration.setAttribute(
				IJavaLaunchConfigurationConstants.ATTR_VM_ARGUMENTS,
				DEFAULT_VM_ARGUMENTS);
	}
}
