package de.fernunihagen.rtt.ui.internal.jdt.launcher;

import org.contract4j5.contract.Contract;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Tool test content provider.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class ToolTestContentProvider implements ITreeContentProvider {

	private static final Object[] NO_ELEMENTS = new Object[0];

	/**
	 * Creates a tool test content provider.
	 */
	public ToolTestContentProvider() {
	}

	@Override
	public Object[] getChildren(final Object parentElement) {
		return NO_ELEMENTS;
	}

	@Override
	public Object getParent(final Object element) {
		return null;
	}

	@Override
	public boolean hasChildren(final Object element) {
		return false;
	}

	@Override
	public Object[] getElements(final Object inputElement) {
		if (null != inputElement
				&& inputElement instanceof ToolTestConfiguration) {
			return ((ToolTestConfiguration) inputElement).getAllTestMembers();
		}
		return NO_ELEMENTS;
	}

	@Override
	public void dispose() {
	}

	@Override
	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {
	}

}
