package de.fernunihagen.rtt.ui.internal.view;

import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;
import org.eclipse.jface.viewers.ViewerCell;

import de.fernunihagen.rtt.framework.ITestElement;
import de.fernunihagen.rtt.ui.internal.util.ViewerField;

/**
 * Test element field run stage
 * 
 * @author Osama El Hosami
 */
public final class TestElementFieldRunStage extends ViewerField {

	@Override
	@Post
	public String getColumnHeaderText() {
		return "Run Stage";
	}

	@Override
	@Post
	public String getID() {
		return "runstage";
	}

	@Override
	@Pre
	public void update(final ViewerCell cell) {
		final ITestElement element = (ITestElement) cell.getElement();
		cell.setText(element.getStage().name());
	}

}
