package de.fernunihagen.rtt;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.ElementType;

/**
 * Test annotation, used to mark a method as test case.
 * 
 * @author Osama El Hosami
 */
@Retention(value = RetentionPolicy.RUNTIME)
@Target(value = { ElementType.METHOD })
public @interface Test {
	/**
	 * Retrieves the selection statement used to collect applicable inputs
	 */
	String value() default "";

	/**
	 * Retrieves the textual description
	 */
	String description() default "";
}
