package de.fernunihagen.rtt.framework;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IProgressMonitor;

/**
 * Test actor state factory interface.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface ITestActorStateFactory {
	/**
	 * Creates a test actor state object.
	 * 
	 * @param session
	 *            Test run session
	 * @param monitor
	 *            The progress monitor to use for reporting progress to the
	 *            user. It is the caller's responsibility to call done() on the
	 *            given monitor. Accepts <code>null</code>, indicating that no
	 *            progress should be reported and that the operation cannot be
	 *            canceled
	 * 
	 * @return Test actor state object
	 * 
	 * @throws CoreException
	 *             <ul>
	 *             <li>If an error occurs</li>
	 *             </ul>
	 */
	@Pre("null != session")
	@Post("null != $return")
	ITestActorState create(ITestRunSession session, IProgressMonitor monitor)
			throws CoreException;
}
