package de.fernunihagen.rtt.framework;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;

import org.eclipse.core.resources.IProject;

/**
 * Test context interface.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface ITestContext extends ITestElementContainer {
	/**
	 * Retrieves the projects in run scope.
	 * 
	 * @return Projects in run scope
	 */
	@Post("null != $return")
	IProject[] getScope();

	/**
	 * Retrieves the associated state object.
	 * 
	 * @return Test actor state object
	 */
	@Post("null != $return")
	ITestActorState getState();
}
