package de.fernunihagen.rtt.framework;

import org.contract4j5.contract.Contract;

/**
 * Test description interface.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface ITestDescription {

	// document structure
	// configuration
	// => projects
	// ==> provider name=(provider)
	// ===> project name=(project)
	// ===> ...
	// ==> ...
	// => actors
	// ==> oracle name=(oracle) continueOnError=(boolean)
	// ===> exclude name=(element identifier)
	// ===> ...
	// ==> ...
	// ==> testadapter name=(testadapter) continueOnError=(boolean)
	// ===> exclude name=(element identifier)
	// ===> ...
	// ===> testbundle name=(symbolicname)
	// ====> testcase name=(classname)
	// ====> ...
	// ==> ...

	/**
	 * Configuration type of test projects
	 */
	String TYPE_PROJECTS = "projects";

	/**
	 * Configuration type of test projects provider
	 */
	String TYPE_PROJECTS_PROVIDER = "provider";

	/**
	 * Configuration type of test projects provider
	 */
	String TYPE_PROJECTS_PROVIDER_PROJECT = "project";

	/**
	 * Configuration type of test actors
	 */
	String TYPE_ACTORS = "actors";

	/**
	 * Configuration type of test actors oracle
	 */
	String TYPE_ACTORS_ORACLE = "oracle";

	/**
	 * Configuration type of test actors testadapter
	 */
	String TYPE_ACTORS_TESTADAPTER = "testadapter";

	/**
	 * Configuration type of test actors actor test bundle
	 */
	String TYPE_ACTORS_ACTOR_TESTBUNDLE = "testbundle";

	/**
	 * Configuration type of test actors actor test bundle test case
	 */
	String TYPE_ACTORS_ACTOR_TESTBUNDLE_TESTCASE = "testcase";

	/**
	 * Configuration type of test actors actor resource exclude
	 */
	String TYPE_ACTORS_ACTOR_EXCLUDE = "exclude";

	/**
	 * Key name of any configuration type
	 */
	String KEY_NAME = "name";

	/**
	 * Key continue on error of test actors actor
	 */
	String KEY_ACTORS_ACTOR_CONTINUEONERROR = "continueOnError";
}
