package de.fernunihagen.rtt.framework;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;

import de.fernunihagen.rtt.framework.model.TestRootRunSession;
import de.fernunihagen.rtt.framework.model.TestRunEvent;
import de.fernunihagen.rtt.framework.util.IObserver;

/**
 * Test run listener interface.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface ITestRunListener extends
		IObserver<TestRootRunSession, ITestRunListener, TestRunEvent> {

	/**
	 * Retrieves the test run listener identifier.
	 * 
	 * @return Identifier
	 */
	@Post("null != $return")
	String getID();

	/**
	 * Retrieves the test run listener name.
	 * 
	 * @return Name
	 */
	@Post("null != $return")
	String getName();	
}
