package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.core.resources.IResource;

import de.fernunihagen.rtt.framework.ITestElementContainer;

/**
 * Resource test element.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class ResourceTestElement extends TestElement {

	@Invar("null != $target")
	private Result _result;
	@Invar("null != $target")
	private final IResource _resource;

	/**
	 * Resource test element.
	 * 
	 * @param parent
	 *            Parent container
	 * @param resource
	 *            Resource
	 */
	@Pre("null != parent && null != resource")
	public ResourceTestElement(final ITestElementContainer parent,
			final IResource resource) {
		super(parent);
		_resource = resource;
		_result = Result.IGNORED;

		parent.add(this);
	}

	/**
	 * Sets the test result.
	 * 
	 * @param result
	 *            Test result
	 */
	@Pre("null != result")
	public void setTestResult(final Result result) {
		_result = result;
	}

	@Override
	@Pre
	public void setProgressState(final ProgressState state) {
		super.setProgressState(state);
	}

	@Override
	@Post
	public Result getTestResult() {
		return _result;
	}

	@Override
	@Post
	public String getLabel() {
		return _resource.getName();
	}

}
