package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestElementContainer;

/**
 * Label test element.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class StructuralTestElement extends TestElement {
	@Invar("null != $target")
	private final String _label;
	@Invar("null != $target")
	private Result _result;

	/**
	 * Label test element.
	 * 
	 * @param parent
	 *            Parent container
	 * @param label
	 *            Label
	 * @param Result
	 *            Test result
	 */
	@Pre("null != parent && null != label")
	StructuralTestElement(final ITestElementContainer parent,
			final String label, final Result result) {
		super(parent);
		_label = label;
		_result = result;

		parent.add(this);
		setProgressState(ProgressState.COMPLETED);
	}

	@Override
	@Post
	public Result getTestResult() {
		return _result;
	}

	@Override
	@Post
	public String getLabel() {
		return _label;
	}
}
