package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestElementContainer;

/**
 * Test element.
 * 
 * @author Osama El Hosami
 */
@Contract
public abstract class TestElement extends AbstractTestElement {

	@Invar("null != $target")
	private final ITestElementContainer _parent;

	/**
	 * Creates a test element.
	 * 
	 * @param parent
	 *            Parent container
	 */
	@Pre("null != parent")
	public TestElement(final ITestElementContainer parent) {
		super();
		_parent = parent;
		setProgressState(ProgressState.COMPLETED);
	}

	@Override
	@Post	
	public ITestElementContainer getParentContainer() {
		return _parent;
	}
}
