package de.fernunihagen.rtt.framework.model;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestActorState;
import de.fernunihagen.rtt.framework.ITestRunSession;

/**
 * Test root run context.
 * 
 * @author Osama El Hosami
 */
@Contract
public class TestRootContext extends TestContext {

	private Object _target;

	/**
	 * Creates a test root run context.
	 * 
	 * @param state
	 *            Test actor state object
	 * @param parent
	 *            Parent test context
	 * @param result
	 *            Initial result value
	 */
	@Pre("null != state && null != parent && null != result")
	public TestRootContext(final ITestActorState state,
			final ITestRunSession parent, final Result result) {
		super(state, parent, result);
		_target = null;
	}

	@Override
	protected boolean reset() {
		_target = null;
		return super.reset();
	}

	@Override
	public Object getTarget() {
		return _target;
	}

	@Override
	public void setTarget(Object target) {
		_target = target;
	}
}
