package de.fernunihagen.rtt.framework.oracle;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestActorProvider;
import de.fernunihagen.rtt.framework.oracle.IOracle.Type;

/**
 * Oracle provider interface.
 * 
 * @author Osama El Hosami
 */
@Contract
public interface IOracleProvider extends ITestActorProvider<IOracle> {
	/**
	 * Collects all oracles of given type.
	 * 
	 * @param type
	 *            Type
	 * 
	 * @return List of oracles matching type
	 */
	@Pre("null != type")
	@Post("null != $return")
	IOracle[] getOracles(Type type);
}
