package de.fernunihagen.rtt.framework.oracle;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestContext;
import de.fernunihagen.rtt.framework.ITestDescription;
import de.fernunihagen.rtt.framework.TestActor;

/**
 * Abstract oracle.
 * 
 * @author Osama El Hosami
 */
@Contract
public abstract class Oracle extends TestActor implements IOracle {

	/**
	 * Creates an abstract oracle.
	 */
	public Oracle() {
		super();
	}

	@Override
	@Post
	public String getTypeName() {
		return ITestDescription.TYPE_ACTORS_ORACLE;
	}

	@Pre
	@Post
	@Override
	protected OracleRunState getState(final ITestContext context) {
		return (OracleRunState) super.getState(context);
	}

	/**
	 * Tests if oracle should continue further verifications on error.
	 * 
	 * @param context
	 *            Run context
	 * 
	 * @return true if oracle should continue further verifications on error
	 */
	@Pre("null != context")
	protected boolean shouldContinueOnError(final ITestContext context) {
		return getState(context).getDescription().shouldContinueOnError();
	}
}
