package de.fernunihagen.rtt.framework.oracle;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Invar;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.core.runtime.IAdaptable;

import de.fernunihagen.rtt.framework.IElementCollector;
import de.fernunihagen.rtt.framework.ITestActor;
import de.fernunihagen.rtt.framework.TestActorRunState;

/**
 * Oracle test run context.
 * 
 * @author Osama El Hosami
 */
@Contract
public class OracleRunState extends TestActorRunState {

	@Invar("null != $target")
	private final OracleRunDescription _description;

	/**
	 * Creates an oracle test run context.
	 * 
	 * @param originator
	 *            Originator
	 * @param collector
	 *            Collector
	 * @param description
	 *            Test description
	 */
	@Pre("null != originator && null != collector && null != description")
	public OracleRunState(final ITestActor originator,
			final IElementCollector<? extends IAdaptable> collector,
			final OracleRunDescription description) {
		super(originator, collector);
		_description = description;
	}

	@Override
	@Post
	public OracleRunDescription getDescription() {
		return _description;
	}

	@Override
	public boolean isActive() {
		return false;
	}

	@Override
	public void reset() {
		// nothing to be done
	}
}
