package de.fernunihagen.rtt.framework.testadapter;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import de.fernunihagen.rtt.framework.ITestContext;
import de.fernunihagen.rtt.framework.ITestDescription;
import de.fernunihagen.rtt.framework.TestActor;

/**
 * Abstract refactoring test adapter.
 * 
 * @author Osama El Hosami
 */
@Contract
public abstract class RefactoringTestAdapter extends TestActor implements
		IRefactoringTestAdapter {
	/**
	 * Creates an abstract refactoring test adapter.
	 */
	public RefactoringTestAdapter() {
		super();
	}

	@Override
	@Post
	public String getTypeName() {
		return ITestDescription.TYPE_ACTORS_TESTADAPTER;
	}

	@Pre
	@Post
	@Override
	protected RefactoringTestRunState getState(final ITestContext context) {
		return (RefactoringTestRunState) super.getState(context);
	}

}
