package de.fernunihagen.rtt.framework.testadapter;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;

import de.fernunihagen.rtt.framework.TestActorProvider;

/**
 * Refactoring test adapter provider, manages instances of refactoring test
 * adapters, which implement the interface {@link IRefactoringTestAdapter}.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class RefactoringTestAdapterProvider extends
		TestActorProvider<IRefactoringTestAdapter> implements
		IRefactoringTestAdapterProvider {

	/**
	 * Creates a refactoring test adapter provider.
	 */
	public RefactoringTestAdapterProvider() {
		super();
	}

	@Override
	@Post()
	protected IRefactoringTestAdapter[] getEmptyArray() {
		return new IRefactoringTestAdapter[0];
	}
}
