package de.fernunihagen.rtt.internal;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.core.runtime.ProgressMonitorWrapper;

/**
 * Another not cancelable progress monitor.
 * 
 * @author Osama El Hosami
 */
public final class NotCancelableProgressMonitor extends ProgressMonitorWrapper {

	/**
	 * Creates a not cancelable progress monitor
	 * 
	 * @param monitor
	 *            Adaptee
	 */
	public NotCancelableProgressMonitor(final IProgressMonitor monitor) {
		super(null == monitor ? new NullProgressMonitor() : monitor);
	}

	@Override
	public void setCanceled(final boolean b) {
		// ignore set cancel
	}

	@Override
	public boolean isCanceled() {
		return false;
	}
}
