package de.fernunihagen.rtt.internal.jdt;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.contract4j5.contract.Pre;

import org.eclipse.jdt.core.IJavaElement;

import org.eclipse.jdt.core.search.IJavaSearchScope;
import org.eclipse.jdt.core.search.SearchEngine;
import org.eclipse.jdt.core.search.SearchPattern;

/**
 * Search pattern factory.
 * 
 * @author Osama El Hosami
 */
@Contract
public abstract class JavaSearchPatternFactory {

	/**
	 * Creates a search pattern.
	 * 
	 * @return Search pattern
	 */
	@Pre("null != pattern")
	@Post("null != $return")
	public abstract SearchPattern create();

	/**
	 * Retrieves the search scope to use for search.
	 * 
	 * @return Search scope
	 */
	@Post("null != $return")
	public IJavaSearchScope getSearchScope() {
		return SearchEngine.createJavaSearchScope(getRegion());
	}

	/**
	 * Retrieves the element designating the search region.
	 * 
	 * @return Elements designating the search region
	 */
	@Post("null != $return")
	public abstract IJavaElement[] getRegion();
}
