package de.fernunihagen.rtt.internal.testadapter;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Post;
import org.eclipse.core.runtime.CoreException;

import de.fernunihagen.rtt.TestProcedureStep;

/**
 * Initialization test procedure step.
 * 
 * @author Osama El Hosami
 */
@Contract
public final class InitTestProcedureStep extends TestProcedureStep {

	private static final class InitTestProcedureStepHolder {
		static final InitTestProcedureStep _DEFAULT = new InitTestProcedureStep();
	}

	private InitTestProcedureStep() {
	}

	/**
	 * Retrieves the shared instance.
	 * 
	 * @return The shared instance
	 */
	public static InitTestProcedureStep getInstance() {
		return InitTestProcedureStepHolder._DEFAULT;
	}

	@Override
	public void accept(final ITestProcedureStepVisitor visitor)
			throws CoreException {
		visitor.visit(this);
	}

	@Override
	@Post
	public FlowDecision getFlowDecision() {
		return FlowDecision.NEXT;
	}
}
