package de.fernunihagen.rtt.internal.util;

import org.contract4j5.contract.Contract;
import org.contract4j5.contract.Pre;

/**
 * Generic factory interface.
 * 
 * @author Osama El Hosami
 * 
 * @param <P>
 *            Product type
 * @param <T>
 *            Participant type
 */
@Contract
public interface IFactory<P, T> {
	/**
	 * Creates a new product.
	 * 
	 * @param participant
	 *            Participant
	 * @param key
	 *            Product key
	 * 
	 * @return Product instance
	 */
	@Pre("null != participant && null != key")
	P create(T participant, Object key);
}
